Package net.sf.saxon.pattern

## Class NameTest

- java.lang.Object
- - net.sf.saxon.pattern.NodeTest
  - - net.sf.saxon.pattern.NameTest

- All Implemented Interfaces:
    `java.util.function.Predicate<NodeInfo>`, `QNameTest`, `ItemType`, `ItemType.WithSequenceTypeCache`

      public class NameTest
      extends NodeTest
      implements QNameTest

  NodeTest is an interface that enables a test of whether a node has a particular name and type. A NameTest matches the node kind and the namespace URI and the local name. Note that unlike the XPath production called NameTest, this is a test for a specific name, and does not include wildcard matches.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.type.ItemType

      `ItemType.WithSequenceTypeCache`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `NameTest​(int nodeKind, int nameCode, NamePool namePool)` | Create a NameTest to match nodes by their nameCode allocated from the NamePool
    `NameTest​(int nodeKind, java.lang.String uri, java.lang.String localName, NamePool namePool)` | Create a NameTest to match nodes by name
    `NameTest​(int nodeKind, NodeName name, NamePool pool)` | Create a NameTest to match nodes by name

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `equals​(java.lang.Object other)` | Determines whether two NameTests are equal
    `java.util.Optional<java.lang.String>` | `explainMismatch​(Item item, TypeHierarchy th)` | Get extra diagnostic information about why a supplied item does not conform to this item type, if available.
    `java.lang.String` | `exportQNameTest()` | Export the QNameTest as a string for use in a SEF file (typically in a catch clause).
    `java.lang.String` | `generateJavaScriptNameTest​(int targetVersion)` | Generate Javascript code to test if a name matches the test.
    `double` | `getDefaultPriority()` | Determine the default priority of this node test when used on its own as a Pattern
    `int` | `getFingerprint()` | Get the fingerprint required
    `java.lang.String` | `getFullAlphaCode()` | Get the full alpha code for this item type.
    `java.lang.String` | `getLocalPart()` | Get the local name matched by this nametest
    `java.util.function.IntPredicate` | `getMatcher​(NodeVectorTree tree)` | Get a matching function that can be used to test whether numbered nodes in a TinyTree or DominoTree satisfy the node test.
    `StructuredQName` | `getMatchingNodeName()` | Get the name of the nodes matched by this nodetest, if it matches a specific name.
    `NamePool` | `getNamePool()` | Get the NamePool associated with this NameTest
    `java.lang.String` | `getNamespaceURI()` | Get the namespace URI matched by this nametest
    `int` | `getNodeKind()` | Get the node kind that this name test matches
    `int` | `getPrimitiveType()` | Determine the types of nodes to which this pattern applies.
    `java.util.Optional<IntSet>` | `getRequiredNodeNames()` | Get the set of node names allowed by this NodeTest.
    `UType` | `getUType()` | Get the corresponding `UType`.
    `int` | `hashCode()` | Returns a hash code value for the object.
    `boolean` | `matches​(int nodeKind, NodeName name, SchemaType annotation)` | Test whether this node test is satisfied by a given node.
    `boolean` | `matches​(StructuredQName qname)` | Test whether the NameTest matches a given QName
    `boolean` | `test​(NodeInfo node)` | Test whether this node test is satisfied by a given node.
    `java.lang.String` | `toShortString()` |
    `java.lang.String` | `toString()` |

    - ### Methods inherited from class net.sf.saxon.pattern.NodeTest

      `copy, getAtomizedItemType, getBasicAlphaCode, getContentType, getGenre, getPrimitiveItemType, isAtomicType, isAtomizable, isNillable, isPlainType, matches, one, oneOrMore, zeroOrMore, zeroOrOne`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.type.ItemType

      `getNormalizedDefaultPriority, isTrueItemType, toExportString`

    - ### Methods inherited from interface java.util.function.Predicate

      `and, negate, or`

- - ### Constructor Detail

    - #### NameTest

          public NameTest​(int nodeKind,
                          java.lang.String uri,
                          java.lang.String localName,
                          NamePool namePool)

      Create a NameTest to match nodes by name
      Parameters:
        `nodeKind` - the kind of node, for example `Type.ELEMENT`
        `uri` - the namespace URI of the required nodes. Supply "" to match nodes that are in no namespace
        `localName` - the local name of the required nodes. Supply "" to match unnamed nodes
        `namePool` - the namePool holding the name codes
      Since:
        9.0

    - #### NameTest

          public NameTest​(int nodeKind,
                          int nameCode,
                          NamePool namePool)

      Create a NameTest to match nodes by their nameCode allocated from the NamePool
      Parameters:
        `nodeKind` - the kind of node, for example `Type.ELEMENT`
        `nameCode` - the nameCode representing the name of the node
        `namePool` - the namePool holding the name codes
      Since:
        8.4

    - #### NameTest

          public NameTest​(int nodeKind,
                          NodeName name,
                          NamePool pool)

      Create a NameTest to match nodes by name
      Parameters:
        `nodeKind` - the kind of node, for example `Type.ELEMENT`
        `name` - the name of the nodes that this NameTest will match
        `pool` - the namePool holding the name codes
      Since:
        9.4

  - ### Method Detail

    - #### getNamePool

          public NamePool getNamePool()

      Get the NamePool associated with this NameTest
      Returns:
        the NamePool

    - #### getNodeKind

          public int getNodeKind()

      Get the node kind that this name test matches
      Returns:
        the matching node kind

    - #### getUType

          public UType getUType()

      Get the corresponding `UType`. A UType is a union of primitive item types.
      Specified by:
        `getUType` in interface `ItemType`
      Returns:
        the smallest UType that subsumes this item type

    - #### matches

          public boolean matches​(int nodeKind,
                                 NodeName name,
                                 SchemaType annotation)

      Test whether this node test is satisfied by a given node. This method is only fully supported for a subset of NodeTests, because it doesn't provide all the information needed to evaluate all node tests. In particular (a) it can't be used to evaluate a node test of the form element(N,T) or schema-element(E) where it is necessary to know whether the node is nilled, and (b) it can't be used to evaluate a node test of the form document-node(element(X)). This in practice means that it is used (a) to evaluate the simple node tests found in the XPath 1.0 subset used in XML Schema, and (b) to evaluate node tests where the node kind is known to be an attribute.
      Specified by:
        `matches` in class `NodeTest`
      Parameters:
        `nodeKind` - The kind of node to be matched
        `name` - identifies the expanded name of the node to be matched. The value should be null for a node with no name.
        `annotation` - The actual content type of the node
      Returns:
        true if the node matches this node test

    - #### getMatcher

          public java.util.function.IntPredicate getMatcher​(NodeVectorTree tree)

      Description copied from class: `NodeTest`
      Get a matching function that can be used to test whether numbered nodes in a TinyTree or DominoTree satisfy the node test. (Calling this matcher must give the same result as calling `matchesNode(tree.getNode(nodeNr))`, but it may well be faster).
      Overrides:
        `getMatcher` in class `NodeTest`
      Parameters:
        `tree` - the tree against which the returned function will operate
      Returns:
        an IntPredicate; the matches() method of this predicate takes a node number as input, and returns true if and only if the node identified by this node number matches the node test.

    - #### test

          public boolean test​(NodeInfo node)

      Test whether this node test is satisfied by a given node. This alternative method is used in the case of nodes where calculating the fingerprint is expensive, for example DOM or JDOM nodes.
      Specified by:
        `test` in interface `java.util.function.Predicate<NodeInfo>`
      Overrides:
        `test` in class `NodeTest`
      Parameters:
        `node` - the node to be matched
      Returns:
        true if the node test is satisfied by the supplied node, false otherwise

    - #### matches

          public boolean matches​(StructuredQName qname)

      Test whether the NameTest matches a given QName
      Specified by:
        `matches` in interface `QNameTest`
      Parameters:
        `qname` - the QName to be matched
      Returns:
        true if the name matches

    - #### getDefaultPriority

          public final double getDefaultPriority()

      Determine the default priority of this node test when used on its own as a Pattern
      Specified by:
        `getDefaultPriority` in interface `ItemType`
      Specified by:
        `getDefaultPriority` in class `NodeTest`
      Returns:
        the default priority for the pattern

    - #### getFingerprint

          public int getFingerprint()

      Get the fingerprint required
      Overrides:
        `getFingerprint` in class `NodeTest`

    - #### getMatchingNodeName

          public StructuredQName getMatchingNodeName()

      Get the name of the nodes matched by this nodetest, if it matches a specific name. Return null if the node test matches nodes of more than one name
      Overrides:
        `getMatchingNodeName` in class `NodeTest`

    - #### getPrimitiveType

          public int getPrimitiveType()

      Determine the types of nodes to which this pattern applies. Used for optimisation. For patterns that match nodes of several types, return Type.NODE
      Specified by:
        `getPrimitiveType` in interface `ItemType`
      Overrides:
        `getPrimitiveType` in class `NodeTest`
      Returns:
        the type of node matched by this pattern. e.g. Type.ELEMENT or Type.TEXT

    - #### getRequiredNodeNames

          public java.util.Optional<IntSet> getRequiredNodeNames()

      Get the set of node names allowed by this NodeTest. This is returned as a set of Integer fingerprints. A null value indicates that all names are permitted (i.e. that there are no constraints on the node name. The default implementation returns null.
      Overrides:
        `getRequiredNodeNames` in class `NodeTest`
      Returns:
        the set of integer fingerprints of the node names that this node test can match; or absent if the set of names cannot be represented (for example, with the name tests *:xxx or xxx:*)

    - #### getNamespaceURI

          public java.lang.String getNamespaceURI()

      Get the namespace URI matched by this nametest
      Returns:
        the namespace URI (using "" for the "null namepace")

    - #### getLocalPart

          public java.lang.String getLocalPart()

      Get the local name matched by this nametest
      Returns:
        the local name

    - #### toString

          public java.lang.String toString()

      Specified by:
        `toString` in interface `ItemType`
      Overrides:
        `toString` in class `java.lang.Object`

    - #### hashCode

          public int hashCode()

      Returns a hash code value for the object.
      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### equals

          public boolean equals​(java.lang.Object other)

      Determines whether two NameTests are equal
      Overrides:
        `equals` in class `java.lang.Object`

    - #### getFullAlphaCode

          public java.lang.String getFullAlphaCode()

      Description copied from interface: `ItemType`
      Get the full alpha code for this item type. As well as the basic alpha code, this contains additional information, for example `element(EFG)` has a basic alpha code of `NE`, but the full alpha code of `NE nQ{}EFG`.
      Specified by:
        `getFullAlphaCode` in interface `ItemType`

    - #### exportQNameTest

          public java.lang.String exportQNameTest()

      Export the QNameTest as a string for use in a SEF file (typically in a catch clause).
      Specified by:
        `exportQNameTest` in interface `QNameTest`
      Returns:
        a string representation of the QNameTest, suitable for use in export files. The format is a sequence of alternatives separated by vertical bars, where each alternative is one of '*', '*:localname', 'Q{uri}*', or 'Q{uri}local'.

    - #### generateJavaScriptNameTest

          public java.lang.String generateJavaScriptNameTest​(int targetVersion)

      Generate Javascript code to test if a name matches the test.
      Specified by:
        `generateJavaScriptNameTest` in interface `QNameTest`
      Parameters:
        `targetVersion` - the version of Saxon-JS being targeted
      Returns:
        JS code as a string. The generated code will be used as the body of a JS function in which the argument name "q" is an XdmQName object holding the name. The XdmQName object has properties uri and local.

    - #### explainMismatch

          public java.util.Optional<java.lang.String> explainMismatch​(Item item,
                                                                      TypeHierarchy th)

      Get extra diagnostic information about why a supplied item does not conform to this item type, if available. If extra information is returned, it should be in the form of a complete sentence, minus the closing full stop. No information should be returned for obvious cases.
      Specified by:
        `explainMismatch` in interface `ItemType`
      Overrides:
        `explainMismatch` in class `NodeTest`
      Parameters:
        `item` - the item that doesn't match this type
        `th` - the type hierarchy cache
      Returns:
        optionally, a message explaining why the item does not match the type

    - #### toShortString

          public java.lang.String toShortString()

      Overrides:
        `toShortString` in class `NodeTest`